%wideband dictionary framework, MMSE
%SPICE-like dictionary
%non-hyperparameter

clc;
clear all;
close all;

M=20;
t = (1:M-1)';
SNR=[20 20]';
L=200;
B=10;
test_num=1;
itertime=zeros(1,test_num);
Error=zeros(2,test_num);
Error=[];
%%  Monte Carlo Test
for itest=1:test_num
    itest
    doa1=[-20,10];
    K=length(doa1);
    S = (randn(K,L)+1i*randn(K,L))/sqrt(2);
    S = diag(sqrt(10.^(SNR/10)./diag(1/L*(S*S'))))*S;
    Noise = 1/sqrt(2)*(randn(M,L)+1i*randn(M,L));
    uncer=roundn(random('unif',-1,1,1,K),-2);
    doa=doa1+uncer;
    poles=sind(doa);
    smp=0:1:M-1;
    y_true=exp(-1i*pi*(smp)'.*sind(doa))*S;
    y=y_true +Noise;
    range=[-90,90];    
    %% wideband selection
    [group,P_est,fBlock,fBlockplot]=wideband_Estimation(B,y,poles,range);
    max_range=180/B;
    P_noise=P_est(end);
            [group,P_est,fBlock,P_temp]=narrowband_Estimation(B,fBlock,group,y,poles,P_est,fBlockplot,P_noise);
            if length(group)>1
                [Pest,fBlockplottemp]=range_Estimation(fBlock,group,y,poles,P_est,P_temp,max_range);
                
                pest=zeros(size(fBlockplottemp));
                for i=1:size(pest,2)
                    pest(1:length(nonzeros(fBlockplottemp(:,i))),i)=Pest(i);
                end
                
                P_est=nonzeros(vec(pest)); 
                P_est=P_est./max(P_est);
                Tau=diag(1./P_est);              %Tau
                theta_0=sort(nonzeros(vec(fBlockplottemp)),'ascend');
                
                alpha=0;
                [theta_grid,K,iter_time,theta_ori,STEP,grid_number,Error] = Acceleration_RLS(y,theta_0,Tau,alpha,poles,P_noise);
            end
end

 a=666;      