function    [group,P_est,fBlock,P_temp]=narrowband_Estimation(B,fBlock,group,y,poles,P_est,fBlockplot,P_noise)
bandWidth=fBlock(2)-fBlock(1);
M=size(y,1);
L=size(y,2);
t = (1:M-1)';

for i=1:length(group)
    space_temp(i)=fBlockplot(group(i));
end

clear i
bandWidth_new=bandWidth/2;
A1=[];
A = zeros(M,B);
A(1,:)=1;
ii=0;
clear fBlock;
for i=1:length(space_temp)
    ii=ii+1;
    space_new_start(i)=space_temp(i)-bandWidth_new;
    space_new_end(i)=space_temp(i)+bandWidth_new;
    fBlock_new=linspace(space_new_start(i),space_new_end(i),B+1);
    bandWidth=fBlock_new(2)-fBlock_new(1);
    fBlock(:,ii)=fBlock_new(1:B)+ones(1,B).*bandWidth;   %
    
    for iM=1:B
        a = 1./(-1i*pi*t).*(exp(-1i*pi*t*sind( fBlock_new(iM+1))))-...   %dictionary learning
            exp(-1i*pi*t*sind( fBlock_new(iM)));
        A(2:end,iM)=a/norm(a);
    end
    A1=[A1,A];
end

A_noise=ones(M,1);
A_noise=A_noise/norm(A_noise);
A_1=[A1,A_noise];                         %SPICE_like dictionary

clear space_new_start
clear space_new_end

fBlockstart=fBlock(1,:);
fBlock=vec(fBlock);
Pest=zeros(1,length(fBlock)+1);      

ind=[];

for p=1:length(fBlock)
    Pest(p)=1;  
end

Pest(end)=P_est(end);
clear P_est
P_est=Pest;
Tau=diag(1./P_est);              %Tau
fBlockplot=fBlock(1:length(P_est)-1)+ones(length(P_est)-1,1)*bandWidth/2;


tau=diag(Tau);
X=inv(A_1'*A_1+Tau)*A_1'*y;
X_est=[];
for i=1:size(X,1)
    X_est(i)=norm(X(i,:));             %X_i
end
clear i;
P_est=diag(X_est'*X_est/L);       %P_est
P_est=P_est./max(P_est);
figure;
bar(fBlockplot,P_est(1:end-1)',1,'b');
hold on
stem(asind(poles),ones(length(poles),1)*max(P_est),'r^','LineWidth',2);
yline(P_noise,'r:','LineWidth',2);
xlabel('\theta grid')
ylabel('Estimated power')
 xlim([-90,90]);
legend('estimated','true');
set(gca,'FontSize',20);
grid on
box on
% xlabel('\fontname{Simsun}Ӵ')
% ylabel('\fontname{Simsun}һĹ')
% % xlim([-90,90+M]);
% % xticks([-27,-9,9,100])
% % xticklabels({'B_4','B_5','B_6',''})
% legend('\fontname{Simsun}ֵ','\fontname{Simsun}ʵֵ','\fontname{Simsun}ضֵ');
% set(gca,'FontSize',20);
% grid on
% box on

group=[];
g_flag=1;

for ii=1:length(P_est)-1
    if P_est(ii)>P_noise                     %Pruning
        group( g_flag)=ii;
        g_flag= g_flag+1;
    else P_est(ii)=-1;
        fBlockplot(ii)=-1;
    end
end
P_temp=P_est;
P_est(P_est==-1)=[];
 fBlockplot( fBlockplot==-1)=[];
 
 figure;
bar(fBlockplot,P_est(1:end-1)',1,'b');
hold on
stem(asind(poles),ones(length(poles),1)*max(P_est),'r^','LineWidth',2);
yline(P_noise,'r:','LineWidth',2);
xlabel('\theta grid')
ylabel('Estimated power')
xlim([-90,90]);
legend('estimated','true');
set(gca,'FontSize',20);
grid on
box on
% xlabel('\fontname{Simsun}Ƕ/\circ')
% ylabel('\fontname{Simsun}һĹ')
% xlim([-90,90]);
% xticks([-27,-9,9,100])
% xticklabels({'B_4','B_5','B_6',''})
% legend('\fontname{Simsun}ֵ','\fontname{Simsun}ʵֵ','\fontname{Simsun}ضֵ');
% set(gca,'FontSize',20);
% grid on
% box on
end

