function   [Pest,fBlockplottemp]=range_Estimation(fBlock,group,y,poles,P_est,P_temp,max_range)
bandWidth=fBlock(2)-fBlock(1);
M=size(y,1);
L=size(y,2);
t = (1:M-1)';
clear i
g_flag=1;
group_start=[];
group_end=[];
Flag=0;
index_1=0;
ct = 1;
head = 1;
tail = 1;
num=[];
while (ct<numel(group))
    heat = ct;
    ct = ct+1;
    while(ct<=numel(group) && (group(ct)-group(ct-1))==1)
        ct = ct+1;
    end
    tail  = ct-1;
    num = [num;tail-head+1];
end

num_final = [num(1);diff(num)];

if (tail<numel(group))
    num_final=[num_final;1];
end

group_start=zeros(1,length(num_final));
group_start(1)=group(1);
group_end=zeros(1,length(num_final));
group_end(1)=group(num_final(1));
for i=2:length(num_final)
    group_start(i)=group(sum(num_final(1:(i-1)))+1);
    group_end(i)=group(sum(num_final(1:i)));
end
group_num=length(num_final);

clear i
A1=[];
A = zeros(M,1);
A(1,:)=1;
for i=1:group_num
    space_new_start(i)=fBlock(group_start(i));
    space_new_end(i)=fBlock(group_end(i));
    a = 1./(-1i*pi*t).*(exp(-1i*pi*t*sind( space_new_end(i))))-...   %ֵ
        exp(-1i*pi*t*sind( space_new_start(i)));
    A(2:end,i)=a/norm(a);
    A1(:,i)=A(:,i);
end

clear fBlock
fBlock= [space_new_start;space_new_end];
num_temp=ones(size(fBlock,2),1);

for i=1:size(fBlock,2)
    
    if fBlock(2,i)-fBlock(1,i)>1/2*max_range
        num_temp(i)=ceil((fBlock(2,i)-fBlock(1,i))/(1/2*max_range));
    end
    
end

fBlock_new=zeros(max(num_temp)+1,size(fBlock,2));
for i=1:size(fBlock,2)
    if num_temp(i)>1
        fBlock_new(1:num_temp(i)+1,i) = linspace(fBlock(1,i),fBlock(2,i),(num_temp(i)+1));
    else fBlock_new(1:num_temp(i)+1,i)=fBlock(:,i);
    end
end

Pest_temp=zeros(size(fBlock_new));
fBlock_newtemp=vec(fBlock_new);
fBlock_newtemp(fBlock_newtemp==0)=[];
fBlockplot=zeros(group_num,1);

Pest=zeros(1,group_num);
for i=1:group_num
    if group_start(i)-group_end(i)==0
        Pest(i)=P_temp(group_start(i));
        fBlockplot(i)=(fBlock(1,i)+fBlock(2,i)+bandWidth/2)/2;
    else
        Pest(i)=sum(P_temp(group_start(i):group_end(i)))/(group_end(i)-group_start(i));
        fBlockplot(i)=(fBlock(1,i)+fBlock(2,i))/2;
    end
    
end


for i=1:size(Pest_temp,2)
    Pest_temp(1:length(nonzeros(fBlock_new(:,i))),i)=Pest(i);
end

fBlockplot_temp=zeros(size(fBlock_new,1)-1,size(fBlock_new,2));
vec_fBlock_new=vec(nonzeros(fBlock_new));


for j=1:size(fBlock_new,2)
        ind=1;
        while ind<length(nonzeros(fBlock_new(:,j)))
        fBlockplot_temp(ind,j)=(fBlock_new(ind+1,j)+fBlock_new(ind,j))/2;
        ind=ind+1;
        end
end

% fBlockplot_temp=vec(nonzeros(fBlockplot_temp));
fBlockplottemp=[fBlock_new;fBlockplot_temp];

clear P_est
P_est=Pest;
P_est=P_est./max(P_est);
figure;
for i=1:group_num
    if fBlock(1,i)==fBlock(2,i)
        rectangle('position',[fBlock(1,i),0,bandWidth/2,P_est(i)],'curvature',[0,0],'edgecolor','b','facecolor','b');
        fBlock(2,i)=fBlock(1,i)+bandWidth/2;
  else
        rectangle('position',[fBlock(1,i)-bandWidth/2,0,(fBlock(2,i)-fBlock(1,i))+bandWidth/2,P_est(i)],'curvature',[0,0],'edgecolor','b','facecolor','b');
    end
    hold on
end
hold on
l2=stem(asind(poles),ones(length(poles),1)*max(P_est),'r^','LineWidth',2);

xlabel('\theta grid')
ylabel('Estimated power')
xlim([-90,90]);
legend('estimated','true');
set(gca,'FontSize',20);
grid on
box on
% xlabel('\fontname{Simsun}Ƕ/\circ')
% ylabel('\fontname{Simsun}һĹ')
% legend('\fontname{Simsun}ֵ','\fontname{Simsun}ʵֵ');
% xlim([-90,90]);
% set(gca,'FontSize',20);
% grid on
% box on

group_num=sum(num_temp);




end

